do
	local _, playerClass = UnitClass("player")
	if playerClass ~= "WARLOCK" then return end
end

local MODULE_NAME = "DemonLock"
local Faceroller = _G["Faceroller"]
local gsi = Faceroller.gsi


local SB   = 686 -- Shadowbolt

local CORR = 172 -- Corruption
local IMMO = 348 -- Immolate

local DOOM = 603 -- Bane of Doom
local BOA  = 980 -- Bane of Agony

local COW = 702  -- Curse of Weakness

local COE  = 1490  -- Curse of Elements
local MP   = 93068 -- Rogue Master Poisoner
local EBON = 51160 -- DK Ebon Plauge
local EAM  = 60433 -- Druid Earth and Moon
local PFB  = 34889 -- Hunter Pet Fire Breath
local PLB  = 24844 -- Hunter Pet Lightning Breath
	
local INCIN  = 29722 -- Incinerate
local SF     = 6353  -- Soul Fire
local SHADOW = 47897 -- Shadowflame
local HOG    = 71521 -- Hand of Gul'den
local IA     = 50589 -- Immolation Aura (Demon Form)
local IM     = 50590 -- Immolation

local MCBUFF = 71165 -- Molton Core
local SFBUFF = 63167 -- Decimation
local STBUFF = 17941 -- Shadow Trance
local META   = 47241 -- Metamorphosis
-- local DE     = 47193 -- Old Demonic Empowerment, use Demon Soul instead
local DS     = 77801 -- Demon Soul

-- local LTGLYPH = 45785 -- Life Tap Glyph - Just reduces cooldown now.
-- local LTBUFF = 63321 -- No longer available
local LT = 1454 -- Life Tap

local options
-- local glyphed_lifetap
-- local lifetap_buff

local debug = false

local Init = function(opts)
	
	local spells = {
		[SB] = 0,	-- shadow bolt
		[META] = 0,	-- Metamorph
		[DS] = 0,	-- Demon Soul
		[IA] = 0,
		[HOG] = 0,	-- Hand of Gul'dan
        
	}
	
	options = opts

	if opts.Metamorphasis  == 1 then opts.Metamorphasis  = true end
	if opts.Metamorphasis  == 0 then opts.Metamorphasis  = false end
	
	Faceroller:RegisterDebuff(IMMO, true) -- Mine
	Faceroller:RegisterDebuff(DOOM, true) -- Mine
	Faceroller:RegisterDebuff(CORR, true) -- Mine
	Faceroller:RegisterDebuff(BOA, true)  -- Mine
		
	Faceroller:RegisterDebuff(COE) -- Anyone's
        Faceroller:RegisterDebuff(COE, true) -- Mine
        Faceroller:RegisterDebuff(COW, true) -- Mine
	Faceroller:RegisterDebuff(EBON) -- Check for DK ebon plague, doesn't stack with COE
	Faceroller:RegisterDebuff(EAM)  -- Check for boomkin Earth and Moon debuff, doesn't stack with COE
	Faceroller:RegisterDebuff(MP)   -- Check for Rogue Master Poisoner, doesn't stack with COE
	Faceroller:RegisterDebuff(PFB)  -- Check for Hunter Pet Fire Breath, doesn't stack with COE
	Faceroller:RegisterDebuff(PLB)  -- Check for Hunter Pet Lightning Breath, doesn't stack with COE

			
	Faceroller:RegisterBuff(MCBUFF)
		MC_buff = gsi[MCBUFF]	

	Faceroller:RegisterBuff(SFBUFF)
		SF_buff = gsi[SFBUFF]	

	Faceroller:RegisterBuff(STBUFF)
		ST_buff = gsi[STBUFF]	
		
	Faceroller:RegisterBuff(META)
		Meta_buff = gsi[META]		
		
	
--    glyphed_lifetap = Faceroller:HasGlyph(LTGLYPH)
    
--	if glyphed_lifetap == true then
--        Faceroller:RegisterBuff(LTBUFF)
--		lifetap_buff = gsi[LTBUFF]
--    end
	
	return spells
end


local function GetSpellName(id)
	name, rank, icon, powerCost, isFunnel, powerType, castingTime, minRange, maxRange = GetSpellInfo(id)
	return name
end -- Function GetSpellName


local NextShot = function(gcd, spells, buffs, debuffs, myDebuffs)

	local th = max (0.5, gcd)
	th = th + 0.1
	
	local immolate_threshold = th + 1
	
--	local lifetap = buffs[lifetap_buff]
	local my_corruption = myDebuffs[gsi[CORR]]
	local my_boa        = myDebuffs[gsi[BOA]]
	local my_bod        = myDebuffs[gsi[DOOM]]
	local immolate      = myDebuffs[gsi[IMMO]]
	local my_cow        = myDebuffs[gsi[COW]]	
	
	local MC       = buffs[MC_buff]
	local ST       = buffs[ST_buff]
	local SOUL     = buffs[SF_buff]
	local IMMAURA  = buffs[Meta_buff]
	
	local meta     = spells[META]
	local demons   = spells[DS]
	local ImmoAura = spells[IA]
	local hand     = spells[HOG]
	
	local coe = debuffs[gsi[COE]]
	local my_coe = myDebuffs[gsi[COE]]
	local ebon_plague = debuffs[gsi[EBON]]
	local earth_and_moon = debuffs[gsi[EAM]]
	local master_poison = debuffs[gsi[MP]]  
	local fire_breath = debuffs[gsi[PFB]]  
	local lightning_breath = debuffs[gsi[PLB]]
	
		
	local filler = SB
	
	local next_spell  = filler
	

	-- Shadowbolt (if Shadow Trance is up)
	if ST.active == true then
		next_spell = SB
		if debug == true then print ("NextSpell = Shadowbolt Under shadowTrance") end
		return next_spell
	end			

	-- Lifetap
	if(UnitPower("player") < 10000) then -- My lock, at the time of writing, had 87,000 mana unbuffed.
		next_spell = LT
		if debug == true then print ("NextSpell = ",GetSpellName(next_spell)) end
		return next_spell
	end

	-- Curse of Elements
	if(my_cow.active == false and my_coe.active == false and coe.active == false and ebon_plague.active == false and earth_and_moon.active == false and master_poison.active == false and fire_breath.active == false and lightning_breath.active == false) then
		next_spell = COE
		if debug == true then print ("NextSpell = ",GetSpellName(next_spell)) end
		return next_spell
	end	

	-- Curse of Weakness
	if (my_coe.active == false and my_cow.active == false) or (my_cow.active == true and my_cow.time_left < th) then
		next_spell = COW
		if debug == true then print ("NextSpell = ",GetSpellName(next_spell)) end
		return next_spell
	end	

	-- Metamorphasis
	if(meta.cd < th and options.Metamorphasis  == true) then
		next_spell = META
		if debug == true then print ("NextSpell = ",GetSpellName(next_spell)) end
		return next_spell		
	end	
	
	-- Demon Soul (If Felguard)
	
	if(demons.cd < th) and (UnitCreatureFamily("pet") == "Felguard") then
		next_spell = DS
		if debug == true then print ("NextSpell = ",GetSpellName(next_spell)) end
		return next_spell		
	end	
	
	-- Immolate	
	if (immolate.active == false or immolate.time_left < immolate_threshold) then
		next_spell = IMMO
		if debug == true then print ("NextSpell = ",GetSpellName(next_spell)) end
		return next_spell		
	end

	-- Hand of Gul'dan
	if(hand.cd < th) then
		next_spell = HOG
		if debug == true then print ("NextSpell = ",GetSpellName(next_spell)) end
		return next_spell
	end	
	
	-- Demon Soul (If Felhunter)
	if(demons.cd < th) and (UnitCreatureFamily("pet") ~= "Felguard") then
		next_spell = DS
		if debug == true then print ("NextSpell = ",GetSpellName(next_spell)) end
		return next_spell		
	end	

	-- Bane of Doom	
	if my_boa.active == false and (my_bod.active == false or my_bod.time_left < th) then
		next_spell = DOOM
		if debug == true then print ("NextSpell = ",GetSpellName(next_spell)) end
		return next_spell
	end

	-- Bane of Agony	
	if my_bod.active == false and (my_boa.active == false or my_boa.time_left < th) then
		next_spell = BOA
		if debug == true then print ("NextSpell = ",GetSpellName(next_spell)) end
		return next_spell
	end
	
	-- Corruption
	if(my_corruption.active == false) then
		next_spell = CORR
		if debug == true then print ("NextSpell = ",GetSpellName(next_spell)) end
		return next_spell
	end
	
	-- Incinerate
	if MC.active == true then
		next_spell = INCIN
		if debug == true then print ("NextSpell = ",GetSpellName(next_spell)) end
		return next_spell
	end			

	-- Soulfire
	if SOUL.active == true then
		next_spell = SF	
		if debug == true then print ("NextSpell = ",GetSpellName(next_spell)) end
		return next_spell
	end
	
	-- Immolation Aura
	-- Until there is a way to check melee vs ranged combat, this does not make sense to suggest
	
--	if(ImmoAura.cd < th and IMMAURA.active == true ) then
--		next_spell = IA
--		return next_spell
--	end	
	
	
	return next_spell
end

local Options = function(cmd)
	local Cmd = cmd:lower()

	if Cmd == "meta" then
		if options.Metamorphasis  == true then
			options.Metamorphasis  = false
			print ("FaceRoller: " .. MODULE_NAME .. ": disabled using Metamorphasis")
		else
			options.Metamorphasis  = true
			print ("FaceRoller: " .. MODULE_NAME .. ": enabled using Metamorphasis")
		end
	else
		print ("FaceRoller: " .. MODULE_NAME .. ": Options:")
		print ("FaceRoller: " .. MODULE_NAME .. ": Meta - set 'default' use of Metamorphasis.")
		print ("FaceRoller: " .. MODULE_NAME .. ": Currently using: " .. options.Metamorphasis )
	end
end


Faceroller:RegisterModule(MODULE_NAME, Init, NextShot, Options)
